#include <iostream>
using namespace std;
const int MAXN = 200005;
int a[MAXN];
int q[MAXN][2];
int n, qa, i, j, p, p2;

void input(){
    cin >> n >> qa;
    for(i=1;i<=n;i++){
        cin >> a[i];
    }
    for(i=1;i<=qa;i++){
        cin >> q[i][0] >> q[i][1];
    }
}
void brute(){
    for(i=1;i<=qa;i++){
        p = INT_MAX;
        for(j=q[i][0];j<=q[i][1];j++){
            p&=a[j];
        }
        cout << p << "\n";
    }
}
int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    input();
    brute();
}